算法数组:数组相关题目

704. 二分查找
给定一个 n 个元素有序的(升序)整型数组 nums 和一个目标值 target ,写一个函数搜索 nums 中的 target,如果 target 存在返回下标,否则返回 -1。
你必须编写一个具有 O(log n) 时间复杂度的算法。

解题思路:
有序数组,同时是无重复元素。

关键点:找准闭合还是开区间

闭区间:
关键点:

  • while (left <= right) 要使用 <= ,因为left == right是有意义的,所以使用 <=
  • if (nums[middle] > target) right 要赋值为 middle - 1,因为当前这个nums[middle]一定不是target

``

点击查看代码
class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left = 0;
        int right = nums.size() - 1;
        //[a,b]  双闭空间 终止条件left>right
        while (left <= right) {
            // 中点定义方法
            int middle = left + (right - left) / 2;

            if (target < nums[middle]) {
                // 左区间
                right = middle - 1;

            } else if (target > nums[middle]) {
                left = middle + 1;

            } else
                return middle;
        }

        return -1;
    }
};

开区间,[a,b):
关键点:

  • while (left < right),因为left == right在区间[left, right)没有意义
  • if (nums[middle] > target) right = middle,因为当前nums[middle]不等于target,去左区间继续寻找,而寻找区间是左闭右开区间,所以不会去比较nums[middle]
点击查看代码
class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left = 0;
        int right = nums.size(); // 定义target在左闭右开的区间里,即:[left, right)
        while (left < right) { // 因为left == right的时候,在[left, right)是无效的空间,所以使用 <
            int middle = left + ((right - left) >> 1);
            if (nums[middle] > target) {
                right = middle; // target 在左区间,在[left, middle)中
            } else if (nums[middle] < target) {
                left = middle + 1; // target 在右区间,在[middle + 1, right)中
            } else { // nums[middle] == target
                return middle; // 数组中找到目标值,直接返回下标
            }
        }
        // 未找到目标值
        return -1;
    }
};

35.搜索插入位置
给定一个排序数组和一个目标值,在数组中找到目标值,并返回其索引。如果目标值不存在于数组中,返回它将会被按顺序插入的位置。
你可以假设数组中无重复元素。
nums 为 无重复元素 的 升序 排列数组

解题思路:注意到排序数组 以及无重复元素 查找位置-------> 思考使用二分查找定位

点击查看代码
class Solution {
public:
    int searchInsert(vector<int>& nums, int target) {
        int left = 0;
        int right = nums.size()-1;

        while(left<=right){
            int mid = left+(right-left)/2;
            if(nums[mid]<target){
                //右
                left = mid+1;
            }else if(nums[mid]>target){
                right=mid -1;
            }else return mid;
        }
        return left;   //终止条件 left>right ,此时left = right+ 1;
 
    }
};

不在范围内时:终止条件 left>right ,此时left = right+ 1;

  • 所有下标 < left 的元素:全部 < target
  • 所有下标 > right 的元素:全部 > target

双指针法

  • 双指针法(快慢指针法): 通过一个快指针和慢指针在一个for循环下完成两个for循环的工作。

27. 移除元素
给你一个数组 nums 和一个值 val,你需要 原地 移除所有数值等于 val 的元素,并返回移除后数组的新长度。
不要使用额外的数组空间,你必须仅使用 O(1) 额外空间并原地修改输入数组。
元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素。

解题思路:

首先想到的是这个数组进行遍历,然后寻找目标值相同的元素位置,将他后面元素记录到这个位置,这样的话需要记录当前位置。
那么快慢指针法就很合适:

  • 快指针遍历元素,
  • 慢指针记录现在非目标的元素并且前移,如果快指针遍历到了targer,那么慢指针暂停,快指针继续前进,将下一个非target传给慢指针。最终在慢指针处就可以得到所求无target数组。
点击查看代码
class Solution {
public:
    int removeElement(vector<int>& nums, int val) {
        int slowIndex = 0;
        for (int fastIndex = 0; fastIndex < nums.size(); fastIndex++) {
            if (val != nums[fastIndex]) {
                nums[slowIndex++] = nums[fastIndex];
            }
        }
        return slowIndex;
    }
};

26. 删除有序数组中的重复项
给你一个 非严格递增排列 的数组 nums ,请你 原地 删除重复出现的元素,使每个元素 只出现一次 ,返回删除后数组的新长度。元素的 相对顺序 应该保持 一致 。然后返回 nums 中唯一元素的个数。
考虑 nums 的唯一元素的数量为 k。去重后,返回唯一元素的数量 k。
nums 的前 k 个元素应包含 排序后 的唯一数字。下标 k - 1 之后的剩余元素可以忽略。

解题思路:

快慢指针,条件为fast!=slow,慢指针++,传值。

点击查看代码
class Solution {
public:
    int removeDuplicates(vector<int>& nums) {
        int slow = 0;
        for(int fast =0;fast<nums.size();fast++){
            if(nums[fast]!=nums[slow]){
                slow++;
                nums[slow] = nums[fast];
            }
        }
        return slow+1;
    }
};
posted @ 2026-07-09 11:57  icccey4  阅读(99)  评论(0)    收藏  举报